--- old/usr/src/uts/common/io/comstar/port/qlt/qlt.c	Mon Aug  5 17:27:33 2019
+++ new/usr/src/uts/common/io/comstar/port/qlt/qlt.c	Mon Aug  5 17:27:33 2019
@@ -20,12 +20,12 @@
  */
 
 /*
- * Copyright 2009 QLogic Corporation.  All rights reserved.
+ * Copyright 2009-2015 QLogic Corporation.  All rights reserved.
  * Use is subject to license terms.
  */
 
 /*
- * Copyright (c) 2008, 2010, Oracle and/or its affiliates. All rights reserved.
+ * Copyright (c) 2009, 2015, Oracle and/or its affiliates. All rights reserved.
  */
 
 #include <sys/conf.h>
@@ -39,11 +39,15 @@
 #include <sys/byteorder.h>
 #include <sys/atomic.h>
 #include <sys/scsi/scsi.h>
+#include <sys/time.h>
+#ifdef __x86
+#include <sys/x86_archext.h>
+#endif
 
 #include <sys/stmf_defines.h>
+#include <sys/stmf_ioctl.h>
 #include <sys/fct_defines.h>
 #include <sys/stmf.h>
-#include <sys/stmf_ioctl.h>
 #include <sys/portif.h>
 #include <sys/fct.h>
 
@@ -54,6 +58,10 @@
 
 static int qlt_attach(dev_info_t *dip, ddi_attach_cmd_t cmd);
 static int qlt_detach(dev_info_t *dip, ddi_detach_cmd_t cmd);
+static uint8_t *qlt_vpd_findtag(qlt_state_t *qlt, uint8_t *vpdbuf,
+    int8_t *opcode);
+static int qlt_vpd_lookup(qlt_state_t *qlt, uint8_t *opcode, uint8_t *bp,
+    int32_t bplen);
 static void qlt_enable_intr(qlt_state_t *);
 static void qlt_disable_intr(qlt_state_t *);
 static fct_status_t qlt_reset_chip(qlt_state_t *qlt);
@@ -62,16 +70,19 @@
     uint32_t word_count, uint32_t risc_addr);
 static fct_status_t qlt_raw_mailbox_command(qlt_state_t *qlt);
 static mbox_cmd_t *qlt_alloc_mailbox_command(qlt_state_t *qlt,
-					uint32_t dma_size);
+    uint32_t dma_size);
 void qlt_free_mailbox_command(qlt_state_t *qlt, mbox_cmd_t *mcp);
 static fct_status_t qlt_mailbox_command(qlt_state_t *qlt, mbox_cmd_t *mcp);
 static uint_t qlt_isr(caddr_t arg, caddr_t arg2);
+static uint_t qlt_msix_resp_handler(caddr_t arg, caddr_t arg2);
+static uint_t qlt_msix_default_handler(caddr_t arg, caddr_t arg2);
 static fct_status_t qlt_firmware_dump(fct_local_port_t *port,
     stmf_state_change_info_t *ssci);
 static void qlt_handle_inot(qlt_state_t *qlt, uint8_t *inot);
 static void qlt_handle_purex(qlt_state_t *qlt, uint8_t *resp);
 static void qlt_handle_atio(qlt_state_t *qlt, uint8_t *atio);
-static void qlt_handle_ctio_completion(qlt_state_t *qlt, uint8_t *rsp);
+static void qlt_handle_ctio_completion(qlt_state_t *qlt, uint8_t *rsp,
+    uint16_t qi);
 static void qlt_handle_sol_abort_completion(qlt_state_t *qlt, uint8_t *rsp);
 static void qlt_handle_dereg_completion(qlt_state_t *qlt, uint8_t *rsp);
 static void qlt_handle_unsol_els_completion(qlt_state_t *qlt, uint8_t *rsp);
@@ -78,9 +89,12 @@
 static void qlt_handle_unsol_els_abort_completion(qlt_state_t *qlt,
     uint8_t *rsp);
 static void qlt_handle_sol_els_completion(qlt_state_t *qlt, uint8_t *rsp);
-static void qlt_handle_rcvd_abts(qlt_state_t *qlt, uint8_t *resp);
-static void qlt_handle_abts_completion(qlt_state_t *qlt, uint8_t *resp);
+static void qlt_handle_rcvd_abts(qlt_state_t *qlt, uint8_t *resp, uint16_t qi);
+static void qlt_handle_abts_completion(qlt_state_t *qlt, uint8_t *resp,
+    uint16_t qi);
 static fct_status_t qlt_read_nvram(qlt_state_t *qlt);
+static fct_status_t qlt_read_vpd(qlt_state_t *qlt);
+static fct_status_t qlt_read_rom_image(qlt_state_t *qlt);
 static void qlt_verify_fw(qlt_state_t *qlt);
 static void qlt_handle_verify_fw_completion(qlt_state_t *qlt, uint8_t *rsp);
 fct_status_t qlt_port_start(caddr_t arg);
@@ -92,9 +106,9 @@
 static void qlt_ctl(struct fct_local_port *port, int cmd, void *arg);
 static fct_status_t qlt_force_lip(qlt_state_t *);
 static fct_status_t qlt_do_flogi(struct fct_local_port *port,
-						fct_flogi_xchg_t *fx);
+    fct_flogi_xchg_t *fx);
 void qlt_handle_atio_queue_update(qlt_state_t *qlt);
-void qlt_handle_resp_queue_update(qlt_state_t *qlt);
+void qlt_handle_resp_queue_update(qlt_state_t *qlt, uint16_t qi);
 fct_status_t qlt_register_remote_port(fct_local_port_t *port,
     fct_remote_port_t *rp, fct_cmd_t *login);
 fct_status_t qlt_deregister_remote_port(fct_local_port_t *port,
@@ -123,6 +137,8 @@
 
 static fct_status_t qlt_read_risc_ram(qlt_state_t *qlt, uint32_t addr,
     uint32_t words);
+static fct_status_t qlt_mbx_mpi_ram(qlt_state_t *qlt, uint32_t addr,
+    uint32_t words, uint16_t direction);
 static int qlt_dump_queue(qlt_state_t *qlt, caddr_t qadr, int entries,
     caddr_t buf, uint_t size_left);
 static int qlt_dump_risc_ram(qlt_state_t *qlt, uint32_t addr, uint32_t words,
@@ -139,8 +155,6 @@
 
 static int qlt_el_trace_desc_ctor(qlt_state_t *qlt);
 static int qlt_el_trace_desc_dtor(qlt_state_t *qlt);
-static int qlt_validate_trace_desc(qlt_state_t *qlt);
-static char *qlt_find_trace_start(qlt_state_t *qlt);
 
 static int qlt_read_int_prop(qlt_state_t *qlt, char *prop, int defval);
 static int qlt_read_string_prop(qlt_state_t *qlt, char *prop, char **prop_val);
@@ -151,6 +165,7 @@
     u_longlong_t *result);
 static boolean_t qlt_wwn_overload_prop(qlt_state_t *qlt);
 static int qlt_quiesce(dev_info_t *dip);
+static void qlt_disable_intr(qlt_state_t *qlt);
 static fct_status_t qlt_raw_wrt_risc_ram_word(qlt_state_t *qlt, uint32_t,
     uint32_t);
 static fct_status_t qlt_raw_rd_risc_ram_word(qlt_state_t *qlt, uint32_t,
@@ -158,11 +173,19 @@
 static void qlt_mps_reset(qlt_state_t *qlt);
 static void qlt_properties(qlt_state_t *qlt);
 
+static fct_status_t qlt_mq_create(qlt_state_t *qlt, int idx);
+static fct_status_t qlt_mq_destroy(qlt_state_t *qlt);
 
+static fct_status_t qlt_27xx_get_dmp_template(qlt_state_t *);
+static uint32_t qlt_27xx_dmp_parse_template(qlt_state_t *, qlt_dt_hdr_t *,
+	uint8_t *, uint32_t);
+static int qlt_27xx_dump_ram(qlt_state_t *, uint16_t, uint32_t,
+	uint32_t, uint8_t *);
+
 #define	SETELSBIT(bmp, els)	(bmp)[((els) >> 3) & 0x1F] = \
 	(uint8_t)((bmp)[((els) >> 3) & 0x1F] | ((uint8_t)1) << ((els) & 7))
 
-int qlt_enable_msix = 0;
+int qlt_enable_msix = 1;
 int qlt_enable_msi = 1;
 
 
@@ -206,10 +229,18 @@
 	qlt_quiesce
 };
 
-#ifndef	PORT_SPEED_10G
-#define	PORT_SPEED_10G		16
+#ifndef	PORT_SPEED_16G
+#define	PORT_SPEED_16G		32
 #endif
 
+#ifndef	PORT_SPEED_32G
+#define	PORT_SPEED_32G		64
+#endif
+
+#ifndef QL_NAME
+#define	QL_NAME "qlt"
+#endif
+
 static struct modldrv modldrv = {
 	&mod_driverops,
 	QLT_NAME" "QLT_VERSION,
@@ -222,7 +253,9 @@
 
 void *qlt_state = NULL;
 kmutex_t qlt_global_lock;
-static uint32_t qlt_loaded_counter = 0;
+static	uint32_t qlt_loaded_counter = 0;
+uint8_t qlt_reprocess_attempt_cnt = 5;
+uint32_t qlt_reprocess_delay = 75;	/* default 75 microseconds */
 
 static char *pci_speeds[] = { " 33", "-X Mode 1 66", "-X Mode 1 100",
 			"-X Mode 1 133", "--Invalid--",
@@ -245,9 +278,42 @@
 	0			/* DMA transfer flags */
 };
 
+
+/* Always use 64 bit DMA. */
+static ddi_dma_attr_t qlt_queue_dma_attr_mq_req1 = {
+	DMA_ATTR_V0,		/* dma_attr_version */
+	0,			/* low DMA address range */
+	0xffffffffffffffff,	/* high DMA address range */
+	0xffffffff,		/* DMA counter register */
+	64,			/* DMA address alignment */
+	0xff,			/* DMA burstsizes */
+	1,			/* min effective DMA size */
+	0xffffffff,		/* max DMA xfer size */
+	0xffffffff,		/* segment boundary */
+	1,			/* s/g list length */
+	1,			/* granularity of device */
+	0			/* DMA transfer flags */
+};
+
+/* Always use 64 bit DMA. */
+static ddi_dma_attr_t qlt_queue_dma_attr_mq_rsp1 = {
+	DMA_ATTR_V0,		/* dma_attr_version */
+	0,			/* low DMA address range */
+	0xffffffffffffffff,	/* high DMA address range */
+	0xffffffff,		/* DMA counter register */
+	64,			/* DMA address alignment */
+	0xff,			/* DMA burstsizes */
+	1,			/* min effective DMA size */
+	0xffffffff,		/* max DMA xfer size */
+	0xffffffff,		/* segment boundary */
+	1,			/* s/g list length */
+	1,			/* granularity of device */
+	0			/* DMA transfer flags */
+};
+
+
 /* qlogic logging */
 int enable_extended_logging = 0;
-
 static char qlt_provider_name[] = "qlt";
 static struct stmf_port_provider *qlt_pp;
 
@@ -303,7 +369,6 @@
 	return (mod_info(&modlinkage, modinfop));
 }
 
-
 static int
 qlt_attach(dev_info_t *dip, ddi_attach_cmd_t cmd)
 {
@@ -324,12 +389,17 @@
 		return (DDI_FAILURE);
 	instance = ddi_get_instance(dip);
 
+	cmn_err(CE_CONT, "!Qlogic %s(%d) FCA Driver v%s\n",
+	    QLT_NAME, instance, QLT_VERSION);
+
 	if (ddi_soft_state_zalloc(qlt_state, instance) != DDI_SUCCESS) {
+		cmn_err(CE_WARN, "qlt(%d): soft state alloc failed", instance);
 		return (DDI_FAILURE);
 	}
 
 	if ((qlt = (qlt_state_t *)ddi_get_soft_state(qlt_state, instance)) ==
 	    NULL) {
+		cmn_err(CE_WARN, "qlt(%d): can't get soft state", instance);
 		goto attach_fail_1;
 	}
 
@@ -336,39 +406,282 @@
 	qlt->instance = instance;
 
 	qlt->nvram = (qlt_nvram_t *)kmem_zalloc(sizeof (qlt_nvram_t), KM_SLEEP);
+	qlt->vpd = (uint32_t *)kmem_zalloc(QL_24XX_VPD_SIZE, KM_SLEEP);
 	qlt->dip = dip;
 
 	if (qlt_el_trace_desc_ctor(qlt) != DDI_SUCCESS) {
 		cmn_err(CE_WARN, "qlt(%d): can't setup el tracing", instance);
-		goto attach_fail_1;
+		goto attach_fail_2;
 	}
 
 	EL(qlt, "instance=%d, ptr=%p\n", instance, (void *)qlt);
 
 	if (pci_config_setup(dip, &qlt->pcicfg_acc_handle) != DDI_SUCCESS) {
-		goto attach_fail_2;
+		cmn_err(CE_WARN, "qlt(%d): pci_config_setup failed", instance);
+		goto attach_fail_3;
 	}
+
 	did = PCICFG_RD16(qlt, PCI_CONF_DEVID);
 	if ((did != 0x2422) && (did != 0x2432) &&
 	    (did != 0x8432) && (did != 0x2532) &&
-	    (did != 0x8001)) {
+	    (did != 0x8001) && (did != 0x2031) &&
+	    (did != 0x2071) && (did != 0x2261)) {
 		cmn_err(CE_WARN, "qlt(%d): unknown devid(%x), failing attach",
 		    instance, did);
 		goto attach_fail_4;
 	}
 
-	if ((did & 0xFF00) == 0x8000)
+	if ((did & 0xFFFF) == 0x2071) {
+		qlt->qlt_27xx_chip = 1;
+		qlt->qlt_fcoe_enabled = 0;
+	} else if ((did & 0xFFFF) == 0x2261) {
+		qlt->qlt_27xx_chip = 1;
+		qlt->qlt_fcoe_enabled = 0;
+	} else if ((did & 0xFFFF) == 0x2031) {
+		qlt->qlt_83xx_chip = 1;
+		qlt->qlt_fcoe_enabled = 0;
+	} else if ((did & 0xFFF0) == 0x8000) {
 		qlt->qlt_81xx_chip = 1;
-	else if ((did & 0xFF00) == 0x2500)
+		qlt->qlt_fcoe_enabled = 1;
+	} else if ((did & 0xFF00) == 0x2500)
 		qlt->qlt_25xx_chip = 1;
 
 	dev_acc_attr.devacc_attr_version = DDI_DEVICE_ATTR_V0;
 	dev_acc_attr.devacc_attr_endian_flags = DDI_STRUCTURE_LE_ACC;
 	dev_acc_attr.devacc_attr_dataorder = DDI_STRICTORDER_ACC;
-	if (ddi_regs_map_setup(dip, 2, &qlt->regs, 0, 0x100,
-	    &dev_acc_attr, &qlt->regs_acc_handle) != DDI_SUCCESS) {
-		goto attach_fail_4;
+
+	if ((qlt->qlt_83xx_chip) || (qlt->qlt_27xx_chip)) {
+		int stat_1;
+		off_t regsize_1;
+
+		stat_1 = ddi_dev_regsize(dip, 1, &regsize_1);
+		if (stat_1 != DDI_SUCCESS) {
+			stmf_trace(qlt->qlt_port_alias,
+			    "instance=%d, reg 1 regsize failed,"
+			    " stat %x", instance, stat_1);
+			goto attach_fail_4;
+		}
+
+		if (ddi_regs_map_setup(dip, 1, &qlt->regs, 0, regsize_1,
+		    &dev_acc_attr, &qlt->regs_acc_handle) != DDI_SUCCESS) {
+			cmn_err(CE_NOTE, "qlt(%d) ddi_regs_map_setup failed\n",
+			    instance);
+			goto attach_fail_4;
+		}
+	} else {
+		/*
+		 * 24xx and 25xx: rnumber 0 is config space
+		 * rnumber 1 is for IO space
+		 * rnumber 2 is for MBAR0: ISP, MSIX, PBA
+		 */
+		if (ddi_regs_map_setup(dip, 2, &qlt->regs, 0, 0x100,
+		    &dev_acc_attr, &qlt->regs_acc_handle) != DDI_SUCCESS) {
+			goto attach_fail_4;
+		}
 	}
+
+	if ((qlt->qlt_83xx_chip) || (qlt->qlt_27xx_chip)) {
+
+		uint32_t w32h;
+		uint32_t w32l;
+		int stat;
+		off_t regsize;
+
+		w32l = PCICFG_RD32(qlt, PCI_CONF_BASE2);
+		w32h = PCICFG_RD32(qlt, PCI_CONF_BASE3);
+
+		if ((w32h > 0) || w32l > 0) {
+			stat = ddi_dev_regsize(dip, 2, &regsize);
+			if (stat != DDI_SUCCESS) {
+				stmf_trace(qlt->qlt_port_alias,
+				    "instance=%d, MSI-X regsize failed,"
+				    " stat %x", instance, stat);
+			}
+			stmf_trace(qlt->qlt_port_alias,
+			    "instance=%d, MSI-X MEM Bar size %x",
+			    instance, regsize);
+
+			stat = ddi_regs_map_setup(dip, 2, &qlt->msix_base, 0,
+			    /* ((MQ_MAX_QUEUES * 2) +1) << 2, */
+			    regsize,
+			    &dev_acc_attr, &qlt->msix_acc_handle);
+
+			if (stat != DDI_SUCCESS || qlt->msix_base == NULL ||
+			    qlt->msix_acc_handle == NULL) {
+
+				cmn_err(CE_WARN,
+				    "qlt(%d): can't map MBar for MSI-X",
+				    instance);
+				stmf_trace(qlt->qlt_port_alias,
+				    "instance=%d, MSI-X MEM Bar map fail",
+				    instance);
+
+				if (qlt->msix_acc_handle != NULL) {
+					ddi_regs_map_free(
+					    &qlt->msix_acc_handle);
+				}
+				goto attach_fail_5;
+			}
+		} else {
+			cmn_err(CE_WARN, "qlt(%d): can't setup MBar for MSI-X",
+			    instance);
+			stmf_trace(qlt->qlt_port_alias,
+			    "instance=%d, No MSI-X MEM Bar", instance);
+			goto attach_fail_5;
+		}
+
+		w32l = PCICFG_RD32(qlt, PCI_CONF_BASE4);
+		w32h = PCICFG_RD32(qlt, PCI_CONF_BASE5);
+
+		if ((w32h > 0) || w32l > 0) {
+			stat = ddi_dev_regsize(dip, 3, &regsize);
+			if (stat != DDI_SUCCESS) {
+				stmf_trace(qlt->qlt_port_alias,
+				    "instance=%d, MQ regsize failed, stat %x",
+				    instance, stat);
+			}
+			stmf_trace(qlt->qlt_port_alias,
+			    "instance=%d, MQ MEM Bar size %x",
+			    instance, regsize);
+
+			/* for 83xx the QP pointers are in the 3rd MBar */
+			stat = ddi_regs_map_setup(dip, 3, &qlt->mq_reg_base, 0,
+			    (MQ_MAX_QUEUES * MQBAR_REG_OFFSET),
+			    &dev_acc_attr, &qlt->mq_reg_acc_handle);
+
+			if (stat != DDI_SUCCESS || qlt->mq_reg_base == NULL ||
+			    qlt->mq_reg_acc_handle == NULL) {
+
+				cmn_err(CE_WARN, "qlt(%d): can't map QP MBar",
+				    instance);
+				stmf_trace(qlt->qlt_port_alias,
+				    "instance=%d, QP MEM Bar map fail st:%x",
+				    instance, stat);
+
+				if (qlt->msix_acc_handle != NULL) {
+					ddi_regs_map_free(
+					    &qlt->msix_acc_handle);
+				}
+				if (qlt->mq_reg_acc_handle != NULL) {
+					ddi_regs_map_free(
+					    &qlt->mq_reg_acc_handle);
+				}
+				goto attach_fail_5;
+			} else {
+				qlt->qlt_mq_enabled = 1;
+			}
+		} else {
+			cmn_err(CE_WARN, "qlt(%d): can't setup MBar for QPs",
+			    instance);
+			stmf_trace(qlt->qlt_port_alias,
+			    "instance=%d, No QPs MEM Bar", instance);
+
+			if (qlt->msix_acc_handle != NULL) {
+				ddi_regs_map_free(
+				    &qlt->msix_acc_handle);
+			}
+			goto attach_fail_5;
+		}
+	} else if (qlt->qlt_81xx_chip) {
+
+		uint32_t w32;
+		int stat;
+
+		w32 = PCICFG_RD32(qlt, PCI_CONF_BASE3);
+		if (w32 == 0) {
+
+			cmn_err(CE_WARN, "qlt(%d): can't setup MBar2",
+			    instance);
+			stmf_trace(qlt->qlt_port_alias,
+			    "instance=%d, No MEM Bar2", instance);
+			goto attach_fail_5;
+		}
+
+		stat = ddi_regs_map_setup(dip, 3, &qlt->mq_reg_base, 0,
+		    (MQ_MAX_QUEUES * MQBAR_REG_OFFSET),
+		    &dev_acc_attr, &qlt->mq_reg_acc_handle);
+
+		if (stat != DDI_SUCCESS || qlt->mq_reg_base == NULL ||
+		    qlt->mq_reg_acc_handle == NULL) {
+
+			cmn_err(CE_WARN, "qlt(%d): can't map MBar2",
+			    instance);
+			stmf_trace(qlt->qlt_port_alias,
+			    "instance=%d, MEM Bar2 map fail", instance);
+
+			if (qlt->mq_reg_acc_handle != NULL) {
+				ddi_regs_map_free(&qlt->mq_reg_acc_handle);
+			}
+			goto attach_fail_5;
+		} else {
+			qlt->qlt_mq_enabled = 1;
+		}
+	} else if (qlt->qlt_25xx_chip) {
+		uint32_t w32h;
+		uint32_t w32l;
+		int stat;
+		off_t regsize;
+
+		/* MBAR2 rnumber 3 */
+		w32l = PCICFG_RD32(qlt, PCI_CONF_BASE3);
+		w32h = PCICFG_RD32(qlt, PCI_CONF_BASE4);
+
+		if ((w32h > 0) || (w32l > 0)) {
+			stat = ddi_dev_regsize(dip, 3, &regsize);
+			if (stat != DDI_SUCCESS) {
+				stmf_trace(qlt->qlt_port_alias,
+				"ISP25xx inst=%d, MQ regsize failed, stat %x",
+				    instance, stat);
+				EL(qlt, "ISP25xx MQ regsize failed, stat %x\n",
+				    stat);
+
+			}
+			stmf_trace(qlt->qlt_port_alias,
+			    "ISP25xx instance=%d, MQ MEM Bar size %lx",
+			    instance, regsize);
+			EL(qlt, "ISP25xx MQ MEM Bar (MBAR2) size: %x\n",
+			    regsize);
+
+			stat = ddi_regs_map_setup(dip, 3, &qlt->mq_reg_base, 0,
+			    (MQ_MAX_QUEUES * MQBAR_REG_OFFSET),
+			    &dev_acc_attr, &qlt->mq_reg_acc_handle);
+			if (stat != DDI_SUCCESS || qlt->mq_reg_base == NULL ||
+			    qlt->mq_reg_acc_handle == NULL) {
+				cmn_err(CE_WARN,
+				    "qlt(%d): ISP25xx can't map QP MBar",
+				    instance);
+				stmf_trace(qlt->qlt_port_alias,
+				    "instance=%d, QP MEM Bar map fail st:%x",
+				    instance, stat);
+				if (qlt->mq_reg_acc_handle != NULL) {
+					ddi_regs_map_free(
+					    &qlt->mq_reg_acc_handle);
+				}
+			} else {
+				qlt->qlt_mq_enabled = 1;
+			}
+		} else {
+			stmf_trace(qlt->qlt_port_alias,
+			    "instance=%d, No QPs MEM Bar", instance);
+			EL(qlt,
+			    "ISP25xx can't setup MBar QPs, use baseq\n");
+		}
+	}
+
+	if (qlt->qlt_mq_enabled) {
+		qlt->mq_req = kmem_zalloc(
+		    ((sizeof (qlt_mq_req_ptr_blk_t)) * MQ_MAX_QUEUES),
+		    KM_SLEEP);
+		qlt->mq_resp = kmem_zalloc(
+		    ((sizeof (qlt_mq_rsp_ptr_blk_t)) * MQ_MAX_QUEUES),
+		    KM_SLEEP);
+	} else {
+		qlt->mq_req = kmem_zalloc(
+		    (sizeof (qlt_mq_req_ptr_blk_t)), KM_SLEEP);
+		qlt->mq_resp = kmem_zalloc(
+		    (sizeof (qlt_mq_rsp_ptr_blk_t)), KM_SLEEP);
+	}
+
 	if (did == 0x2422) {
 		uint32_t pci_bits = REG_RD32(qlt, REG_CTRL_STATUS);
 		uint32_t slot = pci_bits & PCI_64_BIT_SLOT;
@@ -392,6 +705,16 @@
 		    (unsigned long long)ret);
 		goto attach_fail_5;
 	}
+	if ((ret = qlt_read_vpd(qlt)) != QLT_SUCCESS) {
+		cmn_err(CE_WARN, "qlt(%d): read vpd failure %llx", instance,
+		    (unsigned long long)ret);
+		goto attach_fail_5;
+	}
+	if ((ret = qlt_read_rom_image(qlt)) != QLT_SUCCESS) {
+		cmn_err(CE_WARN, "qlt(%d): read rom image failure %llx",
+		    instance, (unsigned long long)ret);
+		goto attach_fail_5;
+	}
 
 	qlt_properties(qlt);
 
@@ -413,8 +736,17 @@
 	}
 	if (ncookies != 1)
 		goto attach_fail_8;
-	qlt->req_ptr = qlt->queue_mem_ptr + REQUEST_QUEUE_OFFSET;
-	qlt->resp_ptr = qlt->queue_mem_ptr + RESPONSE_QUEUE_OFFSET;
+
+	/*
+	 * Base queue (0), alwasy available
+	 */
+	qlt->mq_req[0].queue_mem_mq_base_addr =
+	    qlt->mq_req[0].mq_ptr =
+	    qlt->queue_mem_ptr + REQUEST_QUEUE_OFFSET;
+	qlt->mq_resp[0].queue_mem_mq_base_addr =
+	    qlt->mq_resp[0].mq_ptr =
+	    qlt->queue_mem_ptr + RESPONSE_QUEUE_OFFSET;
+
 	qlt->preq_ptr = qlt->queue_mem_ptr + PRIORITY_QUEUE_OFFSET;
 	qlt->atio_ptr = qlt->queue_mem_ptr + ATIO_QUEUE_OFFSET;
 
@@ -422,6 +754,23 @@
 	if (qlt_setup_interrupts(qlt) != DDI_SUCCESS)
 		goto attach_fail_8;
 
+	qlt->qlt_queue_cnt = 1;
+	if ((qlt->qlt_mq_enabled) && (qlt->intr_cnt > 1)) {
+		int i;
+
+		for (i = 1; i < qlt->intr_cnt; i++) {
+			if (qlt_mq_create(qlt, i) != QLT_SUCCESS) {
+				cmn_err(CE_WARN, "qlt(%d) mq create (%d) "
+				    "failed\n", qlt->instance, i);
+				break;
+			}
+			qlt->qlt_queue_cnt++;
+			if (qlt->qlt_queue_cnt >= MQ_MAX_QUEUES)
+				break;
+		}
+	}
+	EL(qlt, "Queue count = %d\n", qlt->qlt_queue_cnt);
+
 	(void) snprintf(qlt->qlt_minor_name, sizeof (qlt->qlt_minor_name),
 	    "qlt%d", instance);
 	(void) snprintf(qlt->qlt_port_alias, sizeof (qlt->qlt_port_alias),
@@ -460,7 +809,9 @@
 		mr = (uint16_t)(mr | (val << 2));
 		PCICFG_WR16(qlt, 0x4E, mr);
 	} else if ((did == 0x2432) || (did == 0x8432) ||
-	    (did == 0x2532) || (did == 0x8001)) {
+	    (did == 0x2532) || (did == 0x8001) ||
+	    (did == 0x2031) || (did == 0x2071) ||
+	    (did == 0x2261)) {
 		if (max_read_size == 128)
 			val = 0;
 		else if (max_read_size == 256)
@@ -495,7 +846,9 @@
 	if (max_payload_size == 11)
 		goto over_max_payload_setting;
 	if ((did == 0x2432) || (did == 0x8432) ||
-	    (did == 0x2532) || (did == 0x8001)) {
+	    (did == 0x2532) || (did == 0x8001) ||
+	    (did == 0x2031) || (did == 0x2071) ||
+	    (did == 0x2261)) {
 		if (max_payload_size == 128)
 			val = 0;
 		else if (max_payload_size == 256)
@@ -525,8 +878,11 @@
 
 	qlt_enable_intr(qlt);
 
-	if (qlt_port_start((caddr_t)qlt) != QLT_SUCCESS)
+	if (qlt_port_start((caddr_t)qlt) != QLT_SUCCESS) {
+		EL(qlt, "qlt_port_start failed, tear down\n");
+		qlt_disable_intr(qlt);
 		goto attach_fail_10;
+	}
 
 	ddi_report_dev(dip);
 	return (DDI_SUCCESS);
@@ -539,6 +895,8 @@
 attach_fail_9:;
 	qlt_destroy_mutex(qlt);
 	qlt_release_intr(qlt);
+	(void) qlt_mq_destroy(qlt);
+
 attach_fail_8:;
 	(void) ddi_dma_unbind_handle(qlt->queue_mem_dma_handle);
 attach_fail_7:;
@@ -546,12 +904,29 @@
 attach_fail_6:;
 	ddi_dma_free_handle(&qlt->queue_mem_dma_handle);
 attach_fail_5:;
+	if (qlt->mq_resp) {
+		kmem_free(qlt->mq_resp,
+		    (qlt->qlt_mq_enabled ?
+		    (sizeof (qlt_mq_rsp_ptr_blk_t) * MQ_MAX_QUEUES) :
+		    (sizeof (qlt_mq_rsp_ptr_blk_t))));
+	}
+	qlt->mq_resp = NULL;
+	if (qlt->mq_req) {
+		kmem_free(qlt->mq_req,
+		    (qlt->qlt_mq_enabled ?
+		    (sizeof (qlt_mq_req_ptr_blk_t) * MQ_MAX_QUEUES) :
+		    (sizeof (qlt_mq_req_ptr_blk_t))));
+	}
+	qlt->mq_req = NULL;
+
 	ddi_regs_map_free(&qlt->regs_acc_handle);
 attach_fail_4:;
 	pci_config_teardown(&qlt->pcicfg_acc_handle);
-	kmem_free(qlt->nvram, sizeof (qlt_nvram_t));
+attach_fail_3:;
 	(void) qlt_el_trace_desc_dtor(qlt);
 attach_fail_2:;
+	kmem_free(qlt->vpd, QL_24XX_VPD_SIZE);
+	kmem_free(qlt->nvram, sizeof (qlt_nvram_t));
 attach_fail_1:;
 	ddi_soft_state_free(qlt_state, instance);
 	return (DDI_FAILURE);
@@ -587,13 +962,59 @@
 
 	qlt_disable_intr(qlt);
 
+	if (qlt->dmp_template_addr != NULL) {
+		(void) ddi_dma_unbind_handle(qlt->dmp_template_dma_handle);
+		ddi_dma_mem_free(&qlt->dmp_template_acc_handle);
+		ddi_dma_free_handle(&qlt->dmp_template_dma_handle);
+	}
+
+	if (qlt->fw_bin_dump_buf != NULL) {
+		kmem_free(qlt->fw_bin_dump_buf, qlt->fw_bin_dump_size);
+		qlt->fw_bin_dump_buf = NULL;
+		qlt->fw_bin_dump_size = 0;
+		qlt->fw_ascii_dump_size = 0;
+	}
+
+	if (qlt->qlt_fwdump_buf) {
+		kmem_free(qlt->qlt_fwdump_buf, qlt->fw_dump_size);
+		qlt->qlt_fwdump_buf = NULL;
+	}
+
 	ddi_remove_minor_node(dip, qlt->qlt_minor_name);
 	qlt_destroy_mutex(qlt);
 	qlt_release_intr(qlt);
+	if (qlt->qlt_mq_enabled == 1) {
+		(void) qlt_mq_destroy(qlt);
+	}
+
 	(void) ddi_dma_unbind_handle(qlt->queue_mem_dma_handle);
 	ddi_dma_mem_free(&qlt->queue_mem_acc_handle);
 	ddi_dma_free_handle(&qlt->queue_mem_dma_handle);
 	ddi_regs_map_free(&qlt->regs_acc_handle);
+
+	if (qlt->mq_resp) {
+		kmem_free(qlt->mq_resp,
+		    (qlt->qlt_mq_enabled ?
+		    (sizeof (qlt_mq_rsp_ptr_blk_t) * MQ_MAX_QUEUES) :
+		    (sizeof (qlt_mq_rsp_ptr_blk_t))));
+	}
+	qlt->mq_resp = NULL;
+	if (qlt->mq_req) {
+		kmem_free(qlt->mq_req,
+		    (qlt->qlt_mq_enabled ?
+		    (sizeof (qlt_mq_req_ptr_blk_t) * MQ_MAX_QUEUES) :
+		    (sizeof (qlt_mq_req_ptr_blk_t))));
+	}
+	qlt->mq_req = NULL;
+
+	if (qlt->qlt_mq_enabled == 1) {
+		if ((qlt->msix_acc_handle != NULL) &&
+		    ((qlt->qlt_83xx_chip == 1) ||
+		    (qlt->qlt_27xx_chip == 1))) {
+			ddi_regs_map_free(&qlt->msix_acc_handle);
+		}
+		ddi_regs_map_free(&qlt->mq_reg_acc_handle);
+	}
 	pci_config_teardown(&qlt->pcicfg_acc_handle);
 	kmem_free(qlt->nvram, sizeof (qlt_nvram_t));
 	cv_destroy(&qlt->mbox_cv);
@@ -622,6 +1043,14 @@
 
 	REG_WR32(qlt, REG_HCCR, HCCR_CMD(CLEAR_HOST_TO_RISC_INTR));
 	REG_WR16(qlt, REG_MBOX0, MBC_STOP_FIRMWARE);
+	REG_WR16(qlt, REG_MBOX(1), 0);
+	REG_WR16(qlt, REG_MBOX(2), 0);
+	REG_WR16(qlt, REG_MBOX(3), 0);
+	REG_WR16(qlt, REG_MBOX(4), 0);
+	REG_WR16(qlt, REG_MBOX(5), 0);
+	REG_WR16(qlt, REG_MBOX(6), 0);
+	REG_WR16(qlt, REG_MBOX(7), 0);
+	REG_WR16(qlt, REG_MBOX(8), 0);
 	REG_WR32(qlt, REG_HCCR, HCCR_CMD(SET_HOST_TO_RISC_INTR));
 	for (timer = 0; timer < 30000; timer++) {
 		stat = REG_RD32(qlt, REG_RISC_STATUS);
@@ -628,19 +1057,46 @@
 		if (stat & RISC_HOST_INTR_REQUEST) {
 			if ((stat & FW_INTR_STATUS_MASK) < 0x12) {
 				REG_WR32(qlt, REG_HCCR,
-				    HCCR_CMD(CLEAR_RISC_PAUSE));
+				    HCCR_CMD(CLEAR_RISC_TO_PCI_INTR));
 				break;
 			}
 			REG_WR32(qlt, REG_HCCR,
-			    HCCR_CMD(CLEAR_HOST_TO_RISC_INTR));
+			    HCCR_CMD(CLEAR_RISC_TO_PCI_INTR));
 		}
 		drv_usecwait(100);
 	}
+
+
+	/* need to ensure no one accesses the hw during the reset 100us */
+	if ((qlt->qlt_83xx_chip) || (qlt->qlt_27xx_chip)) {
+		REG_WR32(qlt, REG_INTR_CTRL, 0);
+		mutex_enter(&qlt->mbox_lock);
+		if (qlt->qlt_mq_enabled == 1) {
+			int i;
+			for (i = 1; i < qlt->qlt_queue_cnt; i++) {
+				mutex_enter(&qlt->mq_req[i].mq_lock);
+			}
+		}
+		mutex_enter(&qlt->mq_req[0].mq_lock);
+		drv_usecwait(40);
+	}
+
 	/* Reset the chip. */
 	REG_WR32(qlt, REG_CTRL_STATUS, CHIP_SOFT_RESET | DMA_SHUTDOWN_CTRL |
 	    PCI_X_XFER_CTRL);
 	drv_usecwait(100);
 
+	if ((qlt->qlt_83xx_chip) || (qlt->qlt_27xx_chip)) {
+		mutex_exit(&qlt->mq_req[0].mq_lock);
+		if (qlt->qlt_mq_enabled == 1) {
+			int i;
+			for (i = 1; i < qlt->qlt_queue_cnt; i++) {
+				mutex_exit(&qlt->mq_req[i].mq_lock);
+			}
+		}
+		mutex_exit(&qlt->mbox_lock);
+	}
+
 	qlt_disable_intr(qlt);
 
 	return (DDI_SUCCESS);
@@ -650,18 +1106,92 @@
 qlt_enable_intr(qlt_state_t *qlt)
 {
 	if (qlt->intr_cap & DDI_INTR_FLAG_BLOCK) {
-		(void) ddi_intr_block_enable(qlt->htable, qlt->intr_cnt);
+		int stat;
+
+		stat = ddi_intr_block_enable(qlt->htable, qlt->intr_cnt);
+		if (stat != DDI_SUCCESS) {
+			stmf_trace(qlt->qlt_port_alias,
+			    "qlt_enable_intr: ddi_intr_block_enable failed:%x",
+			    stat);
+
+			cmn_err(CE_WARN, "!qlt(%d): qlt_enable_intr: "
+			    "ddi_intr_block_enable failed:%x",
+			    qlt->instance, stat);
+		}
+
+#ifndef __sparc
+		else {
+			/* Please see CR6840537, MSI isn't re-enabled x86 */
+			off_t offset;
+			uint8_t val8;
+			ddi_intr_handle_impl_t	*hdlp;
+
+			if (qlt->qlt_81xx_chip || qlt->qlt_25xx_chip) {
+				offset = (off_t)0x8a;
+			} else {
+				offset = (off_t)0x66;
+			}
+
+			hdlp = (ddi_intr_handle_impl_t *)qlt->htable[0];
+			if ((hdlp->ih_state == DDI_IHDL_STATE_ENABLE) &&
+			    (hdlp->ih_type == DDI_INTR_TYPE_MSI)) {
+
+				/* get MSI control */
+				val8 = pci_config_get8(qlt->pcicfg_acc_handle,
+				    offset);
+
+				if ((val8 & 1) == 0) {
+					stmf_trace(qlt->qlt_port_alias,
+					    "qlt(%d): qlt_enable_intr: "
+					    "MSI enable failed (%x)",
+					    qlt->instance, val8);
+
+					/* write enable to MSI control */
+					val8 = (uint8_t)(val8 | 1);
+					pci_config_put8(qlt->pcicfg_acc_handle,
+					    offset, val8);
+
+					/* read back to veriy */
+					val8 = pci_config_get8
+					    (qlt->pcicfg_acc_handle, offset);
+
+					if (val8 & 1) {
+						stmf_trace(qlt->qlt_port_alias,
+						    "qlt(%d): qlt_enable_intr: "
+						    "MSI enabled kludge!(%x)",
+						    qlt->instance, val8);
+					}
+				}
+			}
+		}
+#endif /* x86 specific hack */
 	} else {
 		int i;
-		for (i = 0; i < qlt->intr_cnt; i++)
-			(void) ddi_intr_enable(qlt->htable[i]);
+		int stat = DDI_SUCCESS;
+
+		for (i = 0;
+		    ((i < qlt->intr_cnt) && (stat == DDI_SUCCESS)); i++) {
+			stat = ddi_intr_enable(qlt->htable[i]);
+		}
+		if (stat != DDI_SUCCESS) {
+			stmf_trace(qlt->qlt_port_alias,
+			    "qlt_enable_intr: ddi_intr_enable failed:%x",
+			    stat);
+
+			cmn_err(CE_WARN, "!qlt(%d): qlt_enable_intr: "
+			    "ddi_intr_enable failed:%x", qlt->instance, stat);
+		}
 	}
-	qlt->qlt_intr_enabled = 1;
 }
 
 static void
 qlt_disable_intr(qlt_state_t *qlt)
 {
+	if (qlt->qlt_intr_enabled == 0) {
+		/* ---- If we've disabled it once, just return ---- */
+		return;
+	}
+
 	if (qlt->intr_cap & DDI_INTR_FLAG_BLOCK) {
 		(void) ddi_intr_block_disable(qlt->htable, qlt->intr_cnt);
 	} else {
@@ -690,11 +1220,20 @@
 	qlt->intr_cap = 0;
 }
 
-
 static void
 qlt_init_mutex(qlt_state_t *qlt)
 {
-	mutex_init(&qlt->req_lock, 0, MUTEX_DRIVER,
+	if (qlt->qlt_mq_enabled == 1) {
+		int i;
+
+		for (i = 1; i < MQ_MAX_QUEUES; i++) {
+			mutex_init(&qlt->mq_req[i].mq_lock, 0, MUTEX_DRIVER,
+			    INT2PTR(qlt->intr_pri, void *));
+			mutex_init(&qlt->mq_resp[i].mq_lock, 0, MUTEX_DRIVER,
+			    INT2PTR(qlt->intr_pri, void *));
+		}
+	}
+	mutex_init(&qlt->mq_req[0].mq_lock, 0, MUTEX_DRIVER,
 	    INT2PTR(qlt->intr_pri, void *));
 	mutex_init(&qlt->preq_lock, 0, MUTEX_DRIVER,
 	    INT2PTR(qlt->intr_pri, void *));
@@ -707,13 +1246,20 @@
 static void
 qlt_destroy_mutex(qlt_state_t *qlt)
 {
-	mutex_destroy(&qlt->req_lock);
+	if (qlt->qlt_mq_enabled == 1) {
+		int i;
+
+		for (i = 1; i < MQ_MAX_QUEUES; i++) {
+			mutex_destroy(&qlt->mq_req[i].mq_lock);
+			mutex_destroy(&qlt->mq_resp[i].mq_lock);
+		}
+	}
+	mutex_destroy(&qlt->mq_req[0].mq_lock);
 	mutex_destroy(&qlt->preq_lock);
 	mutex_destroy(&qlt->mbox_lock);
 	mutex_destroy(&qlt->intr_lock);
 }
 
-
 static int
 qlt_setup_msix(qlt_state_t *qlt)
 {
@@ -722,6 +1268,24 @@
 	int itype = DDI_INTR_TYPE_MSIX;
 	int i;
 
+#ifdef __x86
+	if (get_hwenv() == HW_VMWARE) {
+		EL(qlt, "running under hypervisor, disabling MSI-X\n");
+		return (DDI_FAILURE);
+	}
+#endif
+
+	/* check 24xx revision */
+	if ((!qlt->qlt_25xx_chip) && (!qlt->qlt_81xx_chip) &&
+	    (!qlt->qlt_83xx_chip) && (!qlt->qlt_27xx_chip)) {
+		uint8_t rev_id;
+		rev_id = (uint8_t)
+		    pci_config_get8(qlt->pcicfg_acc_handle, PCI_CONF_REVID);
+		if (rev_id < 3) {
+			return (DDI_FAILURE);
+		}
+	}
+
 	ret = ddi_intr_get_nintrs(qlt->dip, itype, &count);
 	if (ret != DDI_SUCCESS || count == 0) {
 		EL(qlt, "ddi_intr_get_nintrs status=%xh, count=%d\n", ret,
@@ -739,16 +1303,35 @@
 		    "qlt_setup_msix: nintrs=%d,avail=%d", count, avail);
 	}
 
+	if ((qlt->qlt_25xx_chip) && (qlt->qlt_mq_enabled == 0)) {
+		count = 2;
+	}
+
 	qlt->intr_size = (int)(count * (int)sizeof (ddi_intr_handle_t));
 	qlt->htable = kmem_zalloc((uint_t)qlt->intr_size, KM_SLEEP);
 	ret = ddi_intr_alloc(qlt->dip, qlt->htable, itype,
 	    DDI_INTR_ALLOC_NORMAL, count, &actual, 0);
+
+	EL(qlt, "qlt_setup_msix: count=%d,avail=%d,actual=%d\n", count,
+	    avail, actual);
+
 	/* we need at least 2 interrupt vectors */
-	if (ret != DDI_SUCCESS || actual < 2) {
+	if (((qlt->qlt_83xx_chip) || (qlt->qlt_27xx_chip)) &&
+	    (ret != DDI_SUCCESS || actual < 2)) {
 		EL(qlt, "ddi_intr_alloc status=%xh, actual=%d\n", ret,
 		    actual);
 		ret = DDI_FAILURE;
 		goto release_intr;
+	} else if ((qlt->qlt_81xx_chip) && (ret != DDI_SUCCESS || actual < 3)) {
+		EL(qlt, "ddi_intr_alloc status=%xh, actual=%d\n", ret,
+		    actual);
+		ret = DDI_FAILURE;
+		goto release_intr;
+	} else if (ret != DDI_SUCCESS || actual < 2) {
+		EL(qlt, "ddi_intr_alloc status=%xh, actual=%d\n", ret,
+		    actual);
+		ret = DDI_FAILURE;
+		goto release_intr;
 	}
 	if (actual < count) {
 		EL(qlt, "requested: %d, received: %d\n", count, actual);
@@ -762,8 +1345,10 @@
 		goto release_intr;
 	}
 	qlt_init_mutex(qlt);
-	for (i = 0; i < actual; i++) {
-		ret = ddi_intr_add_handler(qlt->htable[i], qlt_isr,
+	for (i = 0; i < qlt->intr_cnt; i++) {
+		ret = ddi_intr_add_handler(qlt->htable[i],
+		    (i != 0) ? qlt_msix_resp_handler :
+		    qlt_msix_default_handler,
 		    qlt, INT2PTR((uint_t)i, void *));
 		if (ret != DDI_SUCCESS) {
 			EL(qlt, "ddi_intr_add_handler status=%xh\n", ret);
@@ -780,9 +1365,7 @@
 release_intr:
 	for (i = 0; i < actual; i++)
 		(void) ddi_intr_free(qlt->htable[i]);
-#if 0
-free_mem:
-#endif
+
 	kmem_free(qlt->htable, (uint_t)qlt->intr_size);
 	qlt->htable = NULL;
 	qlt_release_intr(qlt);
@@ -789,7 +1372,6 @@
 	return (ret);
 }
 
-
 static int
 qlt_setup_msi(qlt_state_t *qlt)
 {
@@ -798,6 +1380,11 @@
 	int ret;
 	int i;
 
+	/* 83xx and 27xx doesn't do MSI - don't even bother? */
+	if ((qlt->qlt_83xx_chip) || (qlt->qlt_27xx_chip)) {
+		return (DDI_FAILURE);
+	}
+
 	/* get the # of interrupts */
 	ret = ddi_intr_get_nintrs(qlt->dip, itype, &count);
 	if (ret != DDI_SUCCESS || count == 0) {
@@ -934,18 +1521,16 @@
  * x86 has a bug in the ddi_intr_block_enable/disable area (6562198).
  */
 #ifndef __sparc
-	if (qlt_enable_msi != 0) {
+	if ((qlt_enable_msi != 0) || (qlt_enable_msix != 0)) {
 #endif
 	if (ddi_intr_get_supported_types(qlt->dip, &itypes) != DDI_SUCCESS) {
 		itypes = DDI_INTR_TYPE_FIXED;
 	}
-
 	if (qlt_enable_msix && (itypes & DDI_INTR_TYPE_MSIX)) {
 		if (qlt_setup_msix(qlt) == DDI_SUCCESS)
 			return (DDI_SUCCESS);
 	}
-
-	if (itypes & DDI_INTR_TYPE_MSI) {
+	if (qlt_enable_msi && (itypes & DDI_INTR_TYPE_MSI)) {
 		if (qlt_setup_msi(qlt) == DDI_SUCCESS)
 			return (DDI_SUCCESS);
 	}
